import type { compilation } from 'webpack';
import type HtmlWebpackPlugin from 'html-webpack-plugin';
declare type Default<T1, T2> = T1 extends T2 ? T1 : T2;
export declare type HtmlWebpackPluginHookKeys = keyof HtmlWebpackPlugin.Hooks;
export declare type HookArgs<K extends HtmlWebpackPluginHookKeys> = NonNullable<Parameters<HtmlWebpackPlugin.Hooks[K]['call']>[0]>;
export declare type PatternContext<CTX extends object = HookArgs<'beforeAssetTagGeneration'>> = CTX & {
    chunk: compilation.Chunk;
    filename: string;
};
export declare type PatternFunction<CTX extends PatternContext = PatternContext> = (ctx: PatternContext<CTX>) => RegExp | string;
export declare type Pattern<CTX extends PatternContext = PatternContext> = string | RegExp | PatternFunction<CTX>;
export declare type PositionContext<CTX extends object = HookArgs<'alterAssetTagGroups'>> = CTX & {
    i18nTag: HtmlWebpackPlugin.HtmlTagObject;
};
export declare type PositionFunction<CTX extends PositionContext = PositionContext> = (ctx: CTX) => HtmlWebpackPlugin.HtmlTagObject[];
export declare type Position<CTX extends PositionContext = PositionContext> = 'before' | 'after' | PositionFunction<CTX>;
export declare type ModifyTagContext<CTX extends object = HookArgs<'beforeAssetTagGeneration'>> = CTX & {
    i18nTag: HtmlWebpackPlugin.HtmlTagObject;
};
export declare type ModifyTagFunction<CTX extends ModifyTagContext = ModifyTagContext> = (ctx: CTX) => CTX['i18nTag'];
export interface ConstructorTypeArgs {
    patternContext?: PatternContext;
    modifyTagContext?: ModifyTagContext;
    positionContext?: PositionContext;
}
export interface ConstructorOptions<T extends ConstructorTypeArgs = ConstructorTypeArgs> {
    include?: Pattern<Default<T['patternContext'], PatternContext>>;
    exclude?: Pattern<Default<T['patternContext'], PatternContext>>;
    extractLocale?: Pattern<Default<T['patternContext'], PatternContext>>;
    modifyTag?: ModifyTagFunction<Default<T['modifyTagContext'], ModifyTagContext>>;
    position?: Position<Default<T['positionContext'], PositionContext>>;
}
export {};
